import { r as registerInstance, c as createEvent, h } from './index-996ea621.js';
import { L as LanguageUtils } from './utils-49f2cbe6.js';

const K2btCalendarActionMenu = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.actionClicked = createEvent(this, "actionClicked", 7);
    this.actions = [];
    this.isOpen = false;
  }
  toggleMenu() {
    this.isOpen = !this.isOpen;
  }
  executeAction(action) {
    this.isOpen = false;
    this.actionClicked.emit(action.id);
  }
  closeMenu(ev) {
    if (this.isOpen && this.quickDaySelectorContainer && !this.quickDaySelectorContainer.contains(ev.target))
      this.isOpen = false;
  }
  render() {
    var _a, _b;
    const menuClass = `K2BT_CalendarActionMenu ${this.isOpen ? 'open' : ''}`;
    return ((_b = (_a = this.actions) === null || _a === void 0 ? void 0 : _a.length) !== null && _b !== void 0 ? _b : 0) > 0 ? (h("div", { class: menuClass, ref: c => (this.quickDaySelectorContainer = c) }, h("span", { class: "K2BT_CalendarActionMenu_ToggleButton", onClick: e => {
        e.stopPropagation();
        this.toggleMenu();
      } }), h("div", { class: "K2BT_CalendarActionMenuContents" }, this.isOpen && (h("ul", { class: "K2BT_CalendarActionMenu_Dropdown" }, this.actions.map(action => (h("li", { onClick: e => {
        e.stopPropagation();
        this.executeAction(action);
      } }, h("img", { class: 'K2BT_CalendarActionMenu_Image GX_Image_' + action.imageName + '_Class', src: action.imageUrl, alt: LanguageUtils.getTranslatedMessage(action.name) }), h("span", null, LanguageUtils.getTranslatedMessage(action.name)))))))))) : ('');
  }
};

export { K2btCalendarActionMenu as k2bt_calendar_action_menu };
